# Options are: 
#        -r all tgz untgz zip clean install tar dist check test archiv
#
# send bug-reports to jschulen@altmark.nat.uni-magdeburg.de

# to define CC INC LIB CFLAGS start "sh ./configure"

CFILES = src/spins.c src/spinstri.c src/model.c src/sighand.c
OFILES = src/spinstri.o src/model.o src/spins.o src/sighand.o
FILES = $(CFILES) configure src/complex.h src/spins.h src/sighand.h \
 models/*.h src/spins.mk spins.bat doc/spins.tex src/spinsdef.c utils/*.c

# Format of a make Description File Entry
# The general form of an entry is:
# target1 [target2..]:[:] [parent1..][; command]...
# [(tab) commands]
#
# Translating everything:

.SUFFIXES: .o .c
.c.o:
	$(CC) $(CFLAGS) -c -o $*.o $<

# nur erste Regel oder optional angegebene Regel wird ausgefuehrt!!!
#all:  spin.tgz a.out
all: a.out

src/model.h:
	cp models/mjj16q0.h src/model.h

spin.tgz: $(FILES)
	tar -cf spin.tar $(FILES)
	gzip -c spin.tar >spin.tgz
	rm spin.tar 

.PHONY : zip
zip:
	zip -k -q spin.zip $(FILES)
	@ls -al spin.zip

src/spinsdef.h: spinsdef
	spinsdef  >src/spinsdef.h

spinsdef: src/spinsdef.c
	$(CC) $(CFLAGS) $(LIB) -o spinsdef src/spinsdef.c  

src/spinstri.o: src/spinstri.c src/spinsdef.h src/spins.h src/model.h
	$(CC) $(CFLAGS) -c -o src/spinstri.o src/spinstri.c

src/spins.o: src/spins.c src/spins.h src/model.h src/spinsdef.h src/sighand.h
	$(CC) $(CFLAGS) -c -o src/spins.o src/spins.c

src/model.o: src/model.c src/spins.h src/model.h src/spinsdef.h
	$(CC) $(CFLAGS) -c -o src/model.o src/model.c

src/sighand.o: src/sighand.c
	$(CC) $(CFLAGS) -c -o src/sighand.o src/sighand.c

.PHONY : install
a.out install: $(OFILES)
	$(CC) $(OFILES) $(LIB)
	if test -d ./exe/; then echo "path exist"; else mkdir exe; fi
	mv a.out ./exe/a.out
	@echo "---   spins is now installed on path ./exe/    ---"

.PHONY : tgz dist
dist: tgz
tgz: spin.tgz
	@ls -al spin.tgz

.PHONY : archiv
archiv: spin.tgz
	cp spin.tgz s`date +%y%m%d`.tgz
	@ls -al *.tgz

.PHONY : untgz
untgz:
	gzip -d -c spin.tgz >spin.tar
	tar -xf spin.tar
	rm spin.tar

# PHONY = don't look at file clean, -rm = start rm and ignore errors
.PHONY : clean
clean:
	-rm $(OFILES) spinsdef



